import 'package:generator_common/classes.dart';
import 'package:mock_creator_generator/src/createMockCreator.dart';
import 'package:test/test.dart';

void main() {
  group("createMockCreator", () {
    test("1", () {
      var className = "Stuffer";
      var returnType = "List<String>";
      var params = <NameTypeWithComment>[NameTypeWithComment("name", "String"), NameTypeWithComment("myList", "List<String>")];

      var result = createMockCreator(
        className: className,
        returnType: returnType,
        paramsNormal: params,
        paramsNamed: <NameTypeWithComment>[],
      );

      var expected = """class Stuffer_Mock extends Stuffer {
final List<String> Function(String a, List<String> b) fn;
Stuffer_Mock(this.fn);
List<String> call(String a, List<String> b) => fn(a, b);
}

typedef fn_Stuffer = List<String> Function(String name, List<String> myList);""";

      expect(result.trim(), expected.trim());
    });
  });
}
